<?php
/*
    Time Machine list posts from past on WordPress blog's
    Copyright (C) 2009 Aleksandar Urošević <urke@users.sourceforge.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Plugin Name: Time Machine
Version: 0.0.5.5svn
Plugin URI: http://blog.urosevic.net/wordpress/time-machine/
Author: Aleksandar Urošević
Author URI: http://urosevic.net/
Description: List all public posts published in past on today date, including all years of blogging
*/

function time_machine_init()
{
	if ( !function_exists("register_sidebar_widget") )
	return;
	register_sidebar_widget(__('Time Machine', 'tm'), "time_machine");
	register_widget_control(__('Time Machine', 'tm'), "tm_widget_control");
	load_plugin_textdomain('tm', PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/languages', dirname(plugin_basename(__FILE__)).'/languages');
}

function tm_widget_control()
{
	// Configuration panel for Time Machine Widget
	$options = get_option("time_machine");
	
	if ( !is_array( $options ) )
	{
		$options = array(
			"title"           => __('Time Machine', 'tm'),
			"message"         => __('No entry on current day in past', 'tm'),
			"showifno"        => "1",
			"posts"           => "10",
			"private"         => "0",
			"exclude_pages"   => "1",
			"exclude_current" => "0",
			"display_commentnum" => "0",
			"range"           => "none",
			"rangenum"        => "1",
			"rangetype"       => "both",
			"excerpt"         => "0",
			"excerpt_cut"     => "0",
			"excerpt_length"  => "150",
			"excerpt_before"  => "<br /><small><em>",
			"excerpt_after"   => "</em></small>"
		);
		update_option("time_machine", $options);
	}

	if ( $_POST['tm-Submit'] )
	{
		$options['title']   = htmlspecialchars($_POST['tm-wTitle']);
		$options['message'] = htmlspecialchars($_POST['tm-wMessage']);
		$options['posts']   = htmlspecialchars($_POST['tm-wPosts']);
		$options['showifno']= htmlspecialchars($_POST['tm-wShowIfNo']);
		$options['include_private']      = htmlspecialchars($_POST['tm-wIncludePrivate']);
		$options['exclude_pages']        = htmlspecialchars($_POST['tm-wExcludePages']);
		$options['exclude_current']      = htmlspecialchars($_POST['tm-wExcludeCurrent']);
		$options['display_commentnum']   = htmlspecialchars($_POST['tm-wDisplayCommentNum']);
		$options['range']                = htmlspecialchars($_POST['tm-range']);
		$options['rangenum']             = htmlspecialchars($_POST['tm-rangenum']);
		$options['rangetype']            = htmlspecialchars($_POST['tm-rangetype']);

		$options['excerpt']              = htmlspecialchars($_POST['tm-wShowExcerpt']);
		$options['excerpt_cut']          = htmlspecialchars($_POST['tm-wExcerptCut']);
		$options['excerpt_length']       = htmlspecialchars($_POST['tm-wExcerptLength']);
		$options['excerpt_before']       = htmlentities($_POST['tm-wExcerptBefore']);
		$options['excerpt_after']        = htmlentities($_POST['tm-wExcerptAfter']);

		update_option("time_machine", $options);
	}

	?>
	<p>
	<label for="tm-wTitle"><?php _e('Title', 'tm'); ?>: </label><br />
	<input type="text" id="tm-wTitle" name="tm-wTitle" value="<?php echo $options['title'];?>" /><br /><br />
	<label for="tm-wPosts"><?php _e('Number of posts', 'tm'); ?>: </label><br />
	<input type="text" id="tm-wPosts" name="tm-wPosts" value="<?php echo $options['posts']; ?>" /><br />
	<em><?php _e('Default value is', 'tm'); ?> <strong>10</strong></em><br /><br />
	<label for="tm-wMessage"><?php _e('Message when no posts in past', 'tm'); ?>:</label><br />
	<input type="text" id="tm-wMessage" name="tm-wMessage" value="<?php echo $options['message']; ?>" /><br /><br />
	<input type="checkbox" id="tm-wShowIfNo" name="tm-wShowIfNo" value="1" <?php if ( $options['showifno'] == "1" ) { echo 'checked="yes"'; } ?> /> <label for="tm-wShowIfNo"><?php _e('Show widget if no posts', 'tm'); ?></label><br />
	<input type="checkbox" id="tm-wIncludePrivate" name="tm-wIncludePrivate" value="1" <?php if ( $options['include_private'] == "1" ) { echo 'checked="yes"'; } ?> /> <label for="tm-wIncludePrivate"><?php _e('Include password protected posts in listing?', 'tm'); ?></label><br />
	<input type="checkbox" id="tm-wExcludePages" name="tm-wExcludePages" value="1" <?php if ( $options['exclude_pages'] == "1" ) { echo 'checked="yes"'; } ?> /> <label for="tm-wExcludePages"><?php _e('Exclude pages from listing', 'tm'); ?></label><br />
	<input type="checkbox" id="tm-wExcludeCurrent" name="tm-wExcludeCurrent" value="1" <?php if ( $options['exclude_current'] == "1" ) { echo 'checked="yes"'; } ?> /> <label for="tm-wExcludeCurrent"><?php _e('Exclude current year articles', 'tm'); ?></label><br />
	<input type="checkbox" id="tm-wDisplayCommentNum" name="tm-wDisplayCommentNum" value="1" <?php if ( $options['display_commentnum'] == "1" ) { echo 'checked="yes"'; } ?> /> <label for="tm-wDisplayCommentNum"><?php _e('Display number of comments', 'tm'); ?></label>

<h3><?php _e('Time range', 'tm'); ?></h3>
	<label for="tm-rangenum"><?php _e('Offset', 'tm'); ?>:</label>
	<input type="text" id="tm-rangenum" name="tm-rangenum" value="<?php echo $options['rangenum']; ?>" title="<?php _e("Number of hours/days/weeks/months to make time range before and/or after today date in past years", "tm"); ?>" /><br />
	<input type="radio" id="tm-range" name="tm-range" value="none" <?php if ( $options['range'] == "none" ) { echo "checked"; } ?>/> <label><?php _e("Disable offset", "tm"); ?></label><br />
	<input type="radio" id="tm-range" name="tm-range" value="hours" <?php if ( $options['range'] == "hours" ) { echo "checked"; } ?>/> <label><?php _e("Hours", "tm"); ?></label><br />
	<input type="radio" id="tm-range" name="tm-range" value="days" <?php if ( $options['range'] == "days" ) { echo "checked"; } ?>/> <label><?php _e("Days", "tm"); ?></label><br />
	<input type="radio" id="tm-range" name="tm-range" value="weeks" <?php if ( $options['range'] == "weeks" ) { echo "checked"; } ?>/> <label><?php _e("Weeks", "tm"); ?></label><br />
	<input type="radio" id="tm-range" name="tm-range" value="months" <?php if ( $options['range'] == "months" ) { echo "checked"; } ?>/> <label><?php _e("Months", "tm"); ?></label><br /><br />

<label><?php _e('Range type', 'tm'); ?>:</label><br />
	<input type="radio" id="tm-rangetype" name="tm-rangetype" value="before" <?php if ( $options['rangetype'] == "before" ) { echo "checked"; } ?>/> <label><?php _e("Before [-]", "tm"); ?></label><br />
	<input type="radio" id="tm-rangetype" name="tm-rangetype" value="both" <?php if ( $options['rangetype'] == "both" ) { echo "checked"; } ?>/> <label><?php _e("Both [+/-]", "tm"); ?></label><br />
	<input type="radio" id="tm-rangetype" name="tm-rangetype" value="after" <?php if ( $options['rangetype'] == "after" ) { echo "checked"; } ?>/> <label><?php _e("After [+]", "tm"); ?></label>

<h3><?php _e('Excerpt'); ?></h3>
<input type="checkbox" <?php if ($options['excerpt']) { echo ' checked="checked"'; }; ?> name="tm-wShowExcerpt" id="tm-wShowExcerpt" /> 
<label for="tm-wShowExcerpt"><?php _e('Show post excerpt?', 'tm'); ?></label>
<br /><br />
<label for="tm-wExcerptBefore"><?php _e('Before excerpt', 'tm'); ?> <small>(<?php _e('e.g.', 'tm'); ?> &lt;br /&gt;&lt;em&gt;)</small>:</label>
<input type="text" id="tm-wExcerptBefore" name="tm-wExcerptBefore" value="<?php echo html_entity_decode($options['excerpt_before']); ?>" />
<br />
<label for="tm-wExcerptAfter"><?php _e('After excerpt', 'tm'); ?> <small>(<?php _e('e.g.', 'tm'); ?> &lt;/em&gt;)</small>:</label>
<input type="text" id="tm-wExcerptAfter" name="tm-wExcerptAfter" value="<?php echo html_entity_decode($options['excerpt_after']); ?>" />
<br />
<label for="tm-wExcerptLength"><?php _e('Excerpt length', 'tm'); ?>:</label>
<input type="text" id="tm-wExcerptLength" name="tm-wExcerptLength" value="<?php echo $options['excerpt_length']; ?>" />
<br />
<input type="checkbox" <?php echo ($options['excerpt_cut']) ? ' checked="checked"' : ''; ?> name="tm-wExcerptCut" id="tm-wExcerptCut" /> 
<label for="tm-wCutExcerpt"><?php _e('Shorten post excerpt?', 'tm'); ?></label>
		</tr>

	<input type="hidden" id="tm-Submit" name="tm-Submit" value="1" />
	</p>
<?php
} // function tm_widget_control

function time_machine($args) {

	// get globals
	global $wpdb;
	
	// get widget options (title and number of post to list)
	$options = get_option("time_machine");
    $tm_excerpt        = $options['excerpt'];
	$tm_excerpt_cut    = $options['excerpt_cut'];
	$tm_excerpt_length = $options['excerpt_length'];
	$tm_excerpt_before = html_entity_decode($options['excerpt_before']);
	$tm_excerpt_after  = html_entity_decode($options['excerpt_after']);

	// display password protected posts or not?
	if ( $options['include_private'] <> "1" ) { $tm_private = "AND post_password=''"; } else { $tm_private = ""; }

	// exclude pages from listing?
	if ( $options['exclude_pages'] == "1" ) { $tm_pages = "AND post_type <> 'page'"; } else { $tm_pages = ""; }
	
	// do we need to exclude current year from query?
	if ( $options['exclude_current'] == "1" ) { $tm_current = "AND `post_date_gmt` NOT LIKE '".gmdate("Y")."-%-% %:%:%'"; } else { $tm_current = ""; }

    // date range
    if ( $options['range'] != "none" ) {
		// define range for every year
		for ( $tm_y = 2004; $tm_y < 2009; $tm_y++ ) {
    		$tm_backday   = "$tm_y-" . gmdate("m-d H:i:s");
    		// get range type
    		$date_start = gmdate("Y-m-d H:i:s", strtotime($tm_backday. ' -' . $options['rangenum'] . ' ' . $options['range']) ); 
    		$date_end   = gmdate("Y-m-d H:i:s", strtotime($tm_backday. ' +' . $options['rangenum'] . ' ' . $options['range']) ); 
    		switch ( $options['rangetype'] ) {
    			case "before":
    				$q_date_start = $date_start;
    				$q_date_end   = $tm_backday;
    				break;

    			case "after":
    				$q_date_start = $tm_backday;
    				$q_date_end   = $date_end;
    				break;
    				
    			default:
    			# both
    				$q_date_start = $date_start;
    				$q_date_end   = $date_end;    			
			}
			

			$q_range .= "$q_or`post_date` BETWEEN '".$q_date_start."' AND '".$q_date_end."'";
			$q_or = " OR ";
		}
		$q_range = "($q_range)";
		
			// format title description
			$tm_before_title = '<span style="cursor:help;" title="'.$options['rangenum'].' ';
			
			switch ( $options['range'] ) {
				case "hours":
					$tm_before_title .= __("hours", "tm");
					break;
				case "days":
					$tm_before_title .= __("days", "tm");
					break;
				case "weeks":
					$tm_before_title .= __("weeks", "tm");
					break;
				case "months":
					$tm_before_title .= __("months", "tm");
					break;
			}
			
			switch ( $options['rangetype'] ) {
				case "before":
					$tm_before_title .= ' '.__("before", "tm").' ';
					break;
				case "after":
					$tm_before_title .= ' '.__("after", "tm").' ';
					break;
				default:
					$tm_before_title .= ' '.__("before and after", "tm").' ';
					break;
			}
			$tm_before_title .= __("today's day in past years", "tm").'">';
			# $tm_before_title = '<span title="'.$options['rangenum'].' '.$options['range'].' '.$options['rangetype'].' today\'s day in past years">';
			$tm_after_title = "</span>";
		
    } else {
		// setup jocker date range
		$tm_time = "2%-".gmdate("m-d")." %:%:%";
		$q_range = "`post_date` LIKE '$tm_time'";
		$tm_before_title = $tm_after_title = "";
	}

	$q = "SELECT ID, post_title, post_date, post_excerpt, comment_count FROM $wpdb->posts WHERE post_status='publish' AND post_type <> 'attachment' AND post_type <> 'revision' $tm_private $tm_pages AND $q_range $tm_current ORDER BY `post_date` LIMIT ".$options['posts'];

	// extract WP args
	extract($args);

	// execute SQL query and track error
	$r = $wpdb->get_results($q, OBJECT);

	// well, to display widget or not?
    if ( ( $options['showifno'] != "1" && $r ) || $options['showifno'] == "1" ) {

	    // print beginning of widget
		echo "$before_widget $before_title $tm_before_title".$options['title']."$tm_after_title $after_title<ul>";

		// check if we got some posts
		if ( $r ) {
			// if we got posts, parse it
			foreach ( $r as $post )
			{
				// prepare excerpt
				if ( $tm_excerpt == TRUE ) {
					$tm_post_excerpt   = $post->post_excerpt;
					if ( $tm_excerpt_cut == TRUE ) {
						if ( $tm_excerpt_length && mb_strlen($tm_post_excerpt) > ($tm_excerpt_length+1) ) { $tm_post_excerpt = tm_substr_utf8($tm_post_excerpt, 0, $tm_excerpt_length)."&hellip;"; }
					}
				}
				
				// print formated post line
				if ( $options['display_commentnum'] == "1" ) { $pcount = ' (<span title="'.__("Number of comments", "tm").'">'.$post->comment_count.'</span>)'; } else { $pcount = ""; }
				echo '<li>'.substr($post->post_date,0,4).': <a href="'.get_permalink($post->ID).'" title="'.__("Published at", "tm").' '.$post->post_date.'">'.$post->post_title.'</a>'.$pcount.' '.$tm_excerpt_before.$tm_post_excerpt.$tm_excerpt_after.'</li>';
			}
		} else {
			// if we have not blog posts on current date in past, print that info
			echo "<li>".$options['message']."</li>";
		}
		echo "</ul>$after_widget";
	} // do not show widget if there is no posts and we don't want to show it

	// flush SQL query
	$wpdb->flush();
}

// unicode substr workaround from http://en.jinzorahelp.com/forums/viewtopic.php?f=18&t=6231
function tm_substr_utf8($str,$from,$len)
{
	# utf8 substr
	# http://www.yeap.lv
	return preg_replace('#^(?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){0,'.$from.'}'.
'((?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){0,'.$len.'}).*#s',
'$1',$str);
}

// Check for uninstall hook
if ( function_exists('register_uninstall_hook') )
	register_uninstall_hook(__FILE__, 'tm_uninstall');

// Delete options from database
function tm_uninstall()
{
	delete_option("time_machine");
}

// initialise Time Machin plugin
add_action("widgets_init", "time_machine_init");
?>
